import tkinter as tk
import tkinter.filedialog as fd
import pandas as pd
import matplotlib.pyplot as plt

def askinfilename(msg = None, types = [('', '*.*')]):
    """
            入力用ファイル名の設定
    """
    rt = tk.Tk()
    rt.withdraw()
    flnm = fd.askopenfilename(title = msg, filetypes = types)
    rt.destroy()
    return flnm

def askoutfilename(msg = None, types = [('', '*.*')], deftype = '.txt'):
    """
            出力用ファイル名の設定
    """
    rt = tk.Tk()
    rt.withdraw()
    flnm = fd.asksaveasfilename(title = msg, filetypes = types,
                                           defaultextension = deftype)
    rt.destroy()
    return flnm


finnm = askinfilename('入力データExcelファイル', types = [('Excel(*.xlsx)', '*.xlsx')])
foutnm = askoutfilename(msg = '画像保存ファイル', types = [('画像 (*.png)', '*.png')],
                       deftype = '.png')

xlsx_fl = pd.ExcelFile(finnm)
data_xlsx = pd.read_excel(xlsx_fl,  header = None)
data = data_xlsx.values

VarName = data[0][0]
Categ = data[1]
counts = data[2]

#       日本語表記の設定
plt.rcParams['font.family'] = ['Yu Gothic', 'Noto Sans CJK JP', 'Hiragino Maru Gothic Pro']

plt.figure(figsize = (8, 6))             #   画像のサイズ
plt.bar(Categ, counts)                   #   ヒストグラムの描画
plt.xticks(fontsize = 18)                #   横軸の目盛り文字の大きさ
plt.yticks(fontsize = 12)                #   縦軸の目盛り文字の大きさ
plt.xlabel(VarName, fontsize = 20)       #   横軸の変数名
plt.ylabel('度数', fontsize = 20)        #    縦軸の名前
plt.savefig(foutnm)                      #   画像の保存
plt.show()                               #   画像の表示

